
REM  NNFie.cmd


set EXE=.exe

set FMT_IE_CMD=NNFie%EXE%
set RUL_IE_CMD=NNRie%EXE%

set NNFIE_FILE=NNFie.exp
set SESSION_NAME=nnfie
set FMT_CMD_FILE=NNFie.cmd

set RUN_NNRIE=1
set USE_CMD_FILE=0


REM #-------------------------------------------------------------------------------
REM # if NNFie is missing, alert users and exit.

if exist %FMT_IE_CMD%  goto step1
	echo NNFie.sh: NNFie is not found in the current directory.
	echo
	exit 

:step1
REM # if NNRie does not exist, warn users and continue. 
if exist %RUL_IE_CMD% goto step2 
	set RUN_NNRIE=0
	echo Warning (NNFie.sh):  NNRie does not exist in the current directory.
	echo     Conditional branching rules will not be exported without NNRie.
	echo

:step2
REM #===============
REM # execute NNFie.
REM #===============

REM # if NNFie failed, then do not run NNRie.  instead, just exit.

set INPUT1=

:temp10
if "%1" == "" goto temp11
  set INPUT1=%INPUT1%+%1 
  shift
  goto temp10

:temp11
  %FMT_IE_CMD% %INPUT1%

  if not exist NNFie.err goto temp12
      echo NNFie.sh: Error occurred during execution of NNFie.
      echo
      exit 


REM #===============================================
REM # execute NNRie for conditional-branching rules.
REM #===============================================

:temp12
if not "%RUN_NNRIE%" == "1" goto endl1
REM        # parse the command-line options to pass them to NNRie.
	
	if "%1" == "-import" goto next1
		goto next1
	if "%1" == "-export" goto next1
		goto next2
:next1
		parse_31_32_cmd.cmd %INPUT1% 
		goto next3
:next2
		parse_40_cmd.cmd %INPUT1%
	      
:next3
	set NNRIE_FILE=%NNFIE_FILE%.rules
    
	if not "%USE_CMD_FILE%" == "0" goto next4 

	   if not "%IE_MODE%" == "IMPORT" goto next5 
	       if exist %NNRIE_FILE%  goto end10
		   %RUL_IE_CMD% -i %NNRIE_FILE% -f %NNRIE_FILE%.failed -s %SESSION_NAME%
		   goto end10
						  
:next5
	   if not "%IE_MODE%" == "EXPORT_ALL" goto next6
	       %RUL_IE_CMD% -e %NNRIE_FILE% -s %SESSION_NAME% -a NNSYRF_FORMATTER
	       goto end10                         
	       
:next6
	   if not "%IE_MODE%" == "EXPORT_BY_NAME" goto next7  
	       %RUL_IE_CMD% -e %NNRIE_FILE% -s %SESSION_NAME% -a NNSYRF_FORMATTER -m $FORMAT_LIST
	       goto end10                     
:next7
	 echo ERROR: invalid import/export mode!
	 exit
	      

:next4
     
REM        # -----------------
REM        # use command file.
REM        # -----------------

		set RUL_CMD_FILE=%FMT_CMD_FILE%.rules
		set TMP_RUL_CMD=type %FMT_CMD_FILE%
		set USE_CMD_FILE=0
		

		parse_40_cmd.cmd %TMP_RUL_CMD%

		set NNRIE_FILE=%NNFIE_FILE%.rules

REM                #
REM                # generate a command file for NNRie.
REM                #
		
		if not "%IE_MODE%" == "IMPORT" goto next10 
		    if not exist %NNRIE_FILE% goto end11
			echo -i %NNRIE_FILE% -f %NNRIE_FILE%.failed -s %SESSION_NAME% > %RUL_CMD_FILE%
			%RUL_IE_CMD% -C %RUL_CMD_FILE%
			goto end11
:next10
		if not "IE_MODE%" == "EXPORT_ALL" goto next11
		    echo -e %NNRIE_FILE% -s %SESSION_NAME% -a NNSYRF_FORMATTER > %RUL_CMD_FILE%
		    %RUL_IE_CMD% -C %RUL_CMD_FILE%
		    goto end11

:next11
		if not "IE_MODE%" == "EXPORT_BY_NAME" goto next12
		    echo -e %NNRIE_FILE% -s %SESSION_NAME% -a NNSYRF_FORMATTER -m %FORMAT_LIST% > %RUL_CMD_FILE%
		    %RUL_IE_CMD% -C %RUL_CMD_FILE%
		    goto end11                              
:next12
	echo ERROR: invalid import/export mode!
	exit 
	
:end11
	if "%IE_MODE%" == "EXPORT_ALL" goto next20
	if "%IE_MODE%" == "EXPORT_BY_NAME" goto next20
	    goto end10
:next20
		if not exist %NNRIE_FILE% goto end10
		  del %NNRIE_FILE%
		  
:end10
       

